/*  autoinst
 *  Copyright (C) 1999 Raymond Medeiros 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <shadow.h>
#include <crypt.h>
#include <gtk/gtk.h>
#include "autoinst.h"
#include "autosig.h"

char package[500];

int
main (int argc, char *argv[])
{
  GtkWidget *dialog1;

  gtk_set_locale ();

  strncpy(package, argv[1], 500);

  gtk_init (&argc, &argv);

  dialog1 = create_dialog1 ();
  gtk_widget_show (dialog1);

  gtk_main ();
  return 0;
}


void
on_button_install_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *entry_text;
        GtkWidget *entry_password;
        GtkWidget *statusbar;
	struct spwd *spass;
        uid_t ruid;
        uid_t euid;

  	entry_password = get_widget (GTK_WIDGET (button), "entry_password");
	statusbar = get_widget (GTK_WIDGET (button), "statusbar1");
	entry_text = gtk_entry_get_text(GTK_ENTRY(entry_password));

        /* Get Real and Effective User ID */

        ruid = getuid();
        euid = getuid();        

        /* Set Real and Effective Uer ID */

        setreuid(0,0);

	/* Try go get a lock on /etc/shadow */
        if (lckpwdf() == -1) 
        {
                perror("Could not Get Lock on password file");
                gtk_exit(1);
        }

	spass = getspnam("root");

	/* Release lock on /etc/shadow */
        if (ulckpwdf() == -1)
        {
                perror("Failure to release lock on password file");
                gtk_exit (1);
        }


	/* Check to see if password is correct */
        if(strcmp(crypt(entry_text,spass->sp_pwdp),spass->sp_pwdp))
        {
		gtk_statusbar_pop (GTK_STATUSBAR (statusbar), 1);
		gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1, "Password Incorrect");	
                return; 
        } 

	gtk_statusbar_pop (GTK_STATUSBAR (statusbar), 1);
	gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1, "Installing...");

        execl("/bin/rpm","rpm","-i",package,NULL);

	/* Restore Real and Effective user ID */

        setreuid(ruid, euid); 
	gtk_exit (0);

	//	return;

}


void
on_button_exit_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_exit (0);
}


void
on_dialog1_remove                      (GtkContainer    *container,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
	gtk_exit (0);
}

